/**
 *
 * @author blossier
 */
public class Cadre extends Employe{
    
    private  Employe[] subordonnes;
    private int nb_subordonnes;
    
    /** Constructeur
     * @param nom : nom de l'employe
     * @param genre : genre de l'employe
     */
    public Cadre(String nom, boolean genre) {
	super(nom,genre);
        this.subordonnes = new Employe[10];
        
    }

    /** Constructeur
     * @param nom : nom de l'employe
     * @param genre : genre de l'employe
     * @param superieur : superieur de l'employe
     */
    public Cadre(String nom, boolean genre, Cadre superieur) {
        super(nom,genre,superieur);
        this.subordonnes = new Employe[10];
	//superieur.ajouteSubordonne(this);
    }
    
    /**
     * Conversion en string pour l'affichage, cette fonction est appelée 
     * automatiquement lors de la conversion en String
     * @return le nom cadre  précédé de la formule de politesse Mr ou Mme 
     */
    public String toString() {
        if (this.getGenre()==Employe._HOMME) {
            return "Mr "+super.toString();
        } else {
            return "Mme "+super.toString();
        }
    }
    
    
    /**
     * Ajoute un subordonné
     * @parem e:  employe a ajouter
     */
    void ajouteSubordonne(Employe e) {
	// on commence par regarder si l'employé n'y est pas déjà
	for (int i = 0; i<this.nb_subordonnes; i++) {
	    if (this.subordonnes[i].equals(e)) {
		// Il est déjà dans le service
		System.out.println(e.getNom() + " est déjà dans le service de " 
                        + this.getNom());
		return;
	    }
	}
	// il n'y est pas 
        //on regarde si le tableau est assez grand (Question facultative)
	if (nb_subordonnes >= subordonnes.length) {
	    // il n'est pas assez grand donc on l'agrandit
	    Employe tab[] = new Employe[subordonnes.length*2];
	    for (int i = 0; i<this.nb_subordonnes; i++) {
		tab[i] = subordonnes[i];
	    }
	    this.subordonnes = tab;		   
	}

	// on ajoute l'employé
	subordonnes[nb_subordonnes] = e;
	nb_subordonnes ++;
    }
    
    /**
     * Affiche sur la sortie standard la liste des subordonnés directs
     */
    public void afficheSubordonnes() {
	System.out.println(this.toString()+ " a "+ nb_subordonnes+ 
                " subordonnés directs :");
	for (int i = 0; i<this.nb_subordonnes; i++) {
	    System.out.println(this.subordonnes[i]);
	}
    }
    
    /**
     * Calcul le salaire
     * @return le salaire de l'employé
     */
    public double getSalaire() {
	double result =  super.getSalaire();
    	for (int i = 0; i<this.nb_subordonnes; i++) {
	    result = result + 0.4*(subordonnes[i].getSalaire());
	}
	return result;
    }
    
    // Questions facultatives:

   /**
     * Enleve un subordonné
     */
    void enleveSubordonne(Employe e) {
	nb_subordonnes --;
	if (subordonnes[nb_subordonnes].equals(e)) return;
	for (int i = 0; i<nb_subordonnes; i++) {
	    if (subordonnes[i].equals(e)){
		subordonnes[i]=subordonnes[nb_subordonnes];
		return;
	    }
	}
	System.out.println(e.getNom()+" n'a pas pour supérieur direct "
                + this.getNom());
	nb_subordonnes ++;
    }

   
    /**
     * Description du service sur la sortie standard
     */
    public void descriptionService() {
	System.out.print("Service de ");
	System.out.println("Ce service est composé de " + afficheService("")+ 
                " personnes.");  
    }

    /**
     * méthode appelée par descriptionService. Elle affiche le service  avec 
     * l'indentation mis en argument et retourne le nombre de personnes 
     * du service
     */
    int afficheService(String ind) {
	int res = super.afficheService(ind);
	if (nb_subordonnes==0) return res;
	if (this.getGenre()==  _HOMME) {
	    System.out.println(ind+" supérieur de :");
	}
	else {
	    System.out.println(ind+" supérieure de :");
	}
	ind = ind+"  ";
	for (int i = 0; i< nb_subordonnes; i++) {
	    res = res+subordonnes[i].afficheService(ind);
	}
	return res;
    }

}
